/* Tabela CARDADIA: CARDADIA */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela CARDADIA */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela CARDADIA,
             utilizando a tabela Geral de Logs de Operaes */

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'LOG_PLA_CARDADIA'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER LOG_PLA_CARDADIA
GO

CREATE TRIGGER LOG_PLA_CARDADIA
ON CARDADIA
AFTER DELETE, INSERT, UPDATE
AS
BEGIN
   DECLARE @V_USUARIO         VARCHAR(40);
   DECLARE @V_TIPO            VARCHAR(1);
   DECLARE @V_ITPESQ          VARCHAR(40);
   DECLARE @V_DESC            VARCHAR(500);
   DECLARE @V_DTOPER          DATETIME;

   DECLARE  @V_DSREMOTEADDR     VARCHAR(15);
   DECLARE  @V_DSREMOTEHOST     VARCHAR(15);
   DECLARE  @V_DSSERVERRDM      VARCHAR(20);
   DECLARE  @V_DSSERVMETHOD     VARCHAR(30);
   DECLARE  @V_DSREMOTEOPER     VARCHAR(12);


/* Variveis do cursor */
   DECLARE @V_IDCOMANDO           VARCHAR(1);
   DECLARE @V_NEW_CDFILIAL        VARCHAR(4);
   DECLARE @V_NEW_NRCARDAPIO      VARCHAR(10);
   DECLARE @V_NEW_CDSERVFILI      VARCHAR(5);
   DECLARE @V_NEW_CDOPERADOR      VARCHAR(12);
   DECLARE @V_NEW_DTCARDAPIO      DATETIME;
   DECLARE @V_NEW_DTMESCARD       DATETIME;
   DECLARE @V_NEW_QTCLIEFETCAR    FLOAT;
   DECLARE @V_NEW_QTFUNEFETCAR    FLOAT;
   DECLARE @V_NEW_QTDOAEFETCAR    FLOAT;
   DECLARE @V_NEW_QTCOMEFETCAR    FLOAT;
   DECLARE @V_NEW_QTCLIESTICAR    FLOAT;
   DECLARE @V_NEW_QTFUNESTICAR    FLOAT;
   DECLARE @V_NEW_QTDOAESTICAR    FLOAT;
   DECLARE @V_NEW_QTCOMESTICAR    FLOAT;
   DECLARE @V_NEW_QTESTITURNO1    FLOAT;
   DECLARE @V_NEW_QTESTITURNO2    FLOAT;
   DECLARE @V_NEW_QTESTITURNO3    FLOAT;
   DECLARE @V_NEW_QTESTITURNO4    FLOAT;
   DECLARE @V_NEW_QTCOMEFETRI     FLOAT;
   DECLARE @V_NEW_QTRESTINGECA    FLOAT;
   DECLARE @V_NEW_QTCOMEFETSL     FLOAT;
   DECLARE @V_NEW_VRPESPORPERC    FLOAT;
   DECLARE @V_NEW_QTSOBRLIMPCA    FLOAT;
   DECLARE @V_NEW_CDDIETPAD       VARCHAR(4);
   DECLARE @V_NEW_CDFILAUXPRRI    VARCHAR(4);
   DECLARE @V_NEW_CDMAIORPRERI    VARCHAR(10);
   DECLARE @V_NEW_CDFILAUXPRSL    VARCHAR(4);
   DECLARE @V_NEW_CDMAIORPRESL    VARCHAR(10);
   DECLARE @V_NEW_DSCARDAPIO      VARCHAR(30);

   DECLARE @V_OLD_CDFILIAL        VARCHAR(4);
   DECLARE @V_OLD_NRCARDAPIO      VARCHAR(10);
   DECLARE @V_OLD_CDSERVFILI      VARCHAR(5);
   DECLARE @V_OLD_CDOPERADOR      VARCHAR(12);
   DECLARE @V_OLD_DTCARDAPIO      DATETIME;
   DECLARE @V_OLD_DTMESCARD       DATETIME;
   DECLARE @V_OLD_QTCLIEFETCAR    FLOAT;
   DECLARE @V_OLD_QTFUNEFETCAR    FLOAT;
   DECLARE @V_OLD_QTDOAEFETCAR    FLOAT;
   DECLARE @V_OLD_QTCOMEFETCAR    FLOAT;
   DECLARE @V_OLD_QTCLIESTICAR    FLOAT;
   DECLARE @V_OLD_QTFUNESTICAR    FLOAT;
   DECLARE @V_OLD_QTDOAESTICAR    FLOAT;
   DECLARE @V_OLD_QTCOMESTICAR    FLOAT;
   DECLARE @V_OLD_QTESTITURNO1    FLOAT;
   DECLARE @V_OLD_QTESTITURNO2    FLOAT;
   DECLARE @V_OLD_QTESTITURNO3    FLOAT;
   DECLARE @V_OLD_QTESTITURNO4    FLOAT;
   DECLARE @V_OLD_QTCOMEFETRI     FLOAT;
   DECLARE @V_OLD_QTRESTINGECA    FLOAT;
   DECLARE @V_OLD_QTCOMEFETSL     FLOAT;
   DECLARE @V_OLD_VRPESPORPERC    FLOAT;
   DECLARE @V_OLD_QTSOBRLIMPCA    FLOAT;
   DECLARE @V_OLD_CDDIETPAD       VARCHAR(4);
   DECLARE @V_OLD_CDFILAUXPRRI    VARCHAR(4);
   DECLARE @V_OLD_CDMAIORPRERI    VARCHAR(10);
   DECLARE @V_OLD_CDFILAUXPRSL    VARCHAR(4);
   DECLARE @V_OLD_CDMAIORPRESL    VARCHAR(10);
   DECLARE @V_OLD_DSCARDAPIO      VARCHAR(30)

   SET  @V_TIPO = '0';
   SET  @V_DESC = '';
  
   EXEC NMUSUARIO @V_USUARIO;
   EXEC WEBTUNNING @V_DSREMOTEADDR,
                   @V_DSREMOTEHOST,
                   @V_DSSERVERRDM,
                   @V_DSSERVMETHOD,
                   @V_DSREMOTEOPER;
  
   SET @V_USUARIO = ISNULL(@V_USUARIO, '');


   DECLARE C_DADOS CURSOR FOR
      SELECT
         'D' IDCOMANDO,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          CDFILIAL,
          NRCARDAPIO,
          CDSERVFILI,
          CDOPERADOR,
          DTCARDAPIO,
          DTMESCARD,
          QTCLIEFETCAR,
          QTFUNEFETCAR,
          QTDOAEFETCAR,
          QTCOMEFETCAR,
          QTCLIESTICAR,
          QTFUNESTICAR,
          QTDOAESTICAR,
          QTCOMESTICAR,
          QTESTITURNO1,
          QTESTITURNO2,
          QTESTITURNO3,
          QTESTITURNO4,
          QTCOMEFETRI,
          QTRESTINGECA,
          QTCOMEFETSL,
          VRPESPORPERC,
          QTSOBRLIMPCA,
          CDDIETPAD,
          CDFILAUXPRRI,
          CDMAIORPRERI,
          CDFILAUXPRSL,
          CDMAIORPRESL,
          DSCARDAPIO

      FROM
         DELETED
      WHERE
         0 = (SELECT COUNT(*) FROM INSERTED)

      UNION ALL

      SELECT
         'U' IDCOMANDO,
          INSERTED.CDFILIAL,
          INSERTED.NRCARDAPIO,
          INSERTED.CDSERVFILI,
          INSERTED.CDOPERADOR,
          INSERTED.DTCARDAPIO,
          INSERTED.DTMESCARD,
          INSERTED.QTCLIEFETCAR,
          INSERTED.QTFUNEFETCAR,
          INSERTED.QTDOAEFETCAR,
          INSERTED.QTCOMEFETCAR,
          INSERTED.QTCLIESTICAR,
          INSERTED.QTFUNESTICAR,
          INSERTED.QTDOAESTICAR,
          INSERTED.QTCOMESTICAR,
          INSERTED.QTESTITURNO1,
          INSERTED.QTESTITURNO2,
          INSERTED.QTESTITURNO3,
          INSERTED.QTESTITURNO4,
          INSERTED.QTCOMEFETRI,
          INSERTED.QTRESTINGECA,
          INSERTED.QTCOMEFETSL,
          INSERTED.VRPESPORPERC,
          INSERTED.QTSOBRLIMPCA,
          INSERTED.CDDIETPAD,
          INSERTED.CDFILAUXPRRI,
          INSERTED.CDMAIORPRERI,
          INSERTED.CDFILAUXPRSL,
          INSERTED.CDMAIORPRESL,
          INSERTED.DSCARDAPIO,

          DELETED.CDFILIAL,
          DELETED.NRCARDAPIO,
          DELETED.CDSERVFILI,
          DELETED.CDOPERADOR,
          DELETED.DTCARDAPIO,
          DELETED.DTMESCARD,
          DELETED.QTCLIEFETCAR,
          DELETED.QTFUNEFETCAR,
          DELETED.QTDOAEFETCAR,
          DELETED.QTCOMEFETCAR,
          DELETED.QTCLIESTICAR,
          DELETED.QTFUNESTICAR,
          DELETED.QTDOAESTICAR,
          DELETED.QTCOMESTICAR,
          DELETED.QTESTITURNO1,
          DELETED.QTESTITURNO2,
          DELETED.QTESTITURNO3,
          DELETED.QTESTITURNO4,
          DELETED.QTCOMEFETRI,
          DELETED.QTRESTINGECA,
          DELETED.QTCOMEFETSL,
          DELETED.VRPESPORPERC,
          DELETED.QTSOBRLIMPCA,
          DELETED.CDDIETPAD,
          DELETED.CDFILAUXPRRI,
          DELETED.CDMAIORPRERI,
          DELETED.CDFILAUXPRSL,
          DELETED.CDMAIORPRESL,
          DELETED.DSCARDAPIO

      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.CDFILIAL    =  DELETED.CDFILIAL    AND
         INSERTED.CDSERVFILI  =  DELETED.CDSERVFILI  AND
         INSERTED.DTCARDAPIO  =  DELETED.DTCARDAPIO

      UNION ALL

      SELECT
         'I' IDCOMANDO,
          CDFILIAL,
          NRCARDAPIO,
          CDSERVFILI,
          CDOPERADOR,
          DTCARDAPIO,
          DTMESCARD,
          QTCLIEFETCAR,
          QTFUNEFETCAR,
          QTDOAEFETCAR,
          QTCOMEFETCAR,
          QTCLIESTICAR,
          QTFUNESTICAR,
          QTDOAESTICAR,
          QTCOMESTICAR,
          QTESTITURNO1,
          QTESTITURNO2,
          QTESTITURNO3,
          QTESTITURNO4,
          QTCOMEFETRI,
          QTRESTINGECA,
          QTCOMEFETSL,
          VRPESPORPERC,
          QTSOBRLIMPCA,
          CDDIETPAD,
          CDFILAUXPRRI,
          CDMAIORPRERI,
          CDFILAUXPRSL,
          CDMAIORPRESL,
          DSCARDAPIO,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL

      FROM
         INSERTED
      WHERE
         0 = (SELECT COUNT(*) FROM DELETED);

   OPEN C_DADOS;
   FETCH NEXT FROM C_DADOS INTO @V_IDCOMANDO,
                                @V_NEW_CDFILIAL,
                                @V_NEW_NRCARDAPIO,
                                @V_NEW_CDSERVFILI,
                                @V_NEW_CDOPERADOR,
                                @V_NEW_DTCARDAPIO,
                                @V_NEW_DTMESCARD,
                                @V_NEW_QTCLIEFETCAR,
                                @V_NEW_QTFUNEFETCAR,
                                @V_NEW_QTDOAEFETCAR,
                                @V_NEW_QTCOMEFETCAR,
                                @V_NEW_QTCLIESTICAR,
                                @V_NEW_QTFUNESTICAR,
                                @V_NEW_QTDOAESTICAR,
                                @V_NEW_QTCOMESTICAR,
                                @V_NEW_QTESTITURNO1,
                                @V_NEW_QTESTITURNO2,
                                @V_NEW_QTESTITURNO3,
                                @V_NEW_QTESTITURNO4,
                                @V_NEW_QTCOMEFETRI,
                                @V_NEW_QTRESTINGECA,
                                @V_NEW_QTCOMEFETSL,
                                @V_NEW_VRPESPORPERC,
                                @V_NEW_QTSOBRLIMPCA,
                                @V_NEW_CDDIETPAD,
                                @V_NEW_CDFILAUXPRRI,
                                @V_NEW_CDMAIORPRERI,
                                @V_NEW_CDFILAUXPRSL,
                                @V_NEW_CDMAIORPRESL,
                                @V_NEW_DSCARDAPIO,

                                @V_OLD_CDFILIAL,
                                @V_OLD_NRCARDAPIO,
                                @V_OLD_CDSERVFILI,
                                @V_OLD_CDOPERADOR,
                                @V_OLD_DTCARDAPIO,
                                @V_OLD_DTMESCARD,
                                @V_OLD_QTCLIEFETCAR,
                                @V_OLD_QTFUNEFETCAR,
                                @V_OLD_QTDOAEFETCAR,
                                @V_OLD_QTCOMEFETCAR,
                                @V_OLD_QTCLIESTICAR,
                                @V_OLD_QTFUNESTICAR,
                                @V_OLD_QTDOAESTICAR,
                                @V_OLD_QTCOMESTICAR,
                                @V_OLD_QTESTITURNO1,
                                @V_OLD_QTESTITURNO2,
                                @V_OLD_QTESTITURNO3,
                                @V_OLD_QTESTITURNO4,
                                @V_OLD_QTCOMEFETRI,
                                @V_OLD_QTRESTINGECA,
                                @V_OLD_QTCOMEFETSL,
                                @V_OLD_VRPESPORPERC,
                                @V_OLD_QTSOBRLIMPCA,
                                @V_OLD_CDDIETPAD,
                                @V_OLD_CDFILAUXPRRI,
                                @V_OLD_CDMAIORPRERI,
                                @V_OLD_CDFILAUXPRSL,
                                @V_OLD_CDMAIORPRESL,
                                @V_OLD_DSCARDAPIO

   WHILE (@@FETCH_STATUS = 0) BEGIN

      IF @V_IDCOMANDO = 'D' /* Deleting */ BEGIN

         IF(ISNULL(@V_OLD_CDFILIAL, '!') <> '!')BEGIN
            SET @V_DESC = @V_DESC + 'Fili=' + @V_OLD_CDFILIAL;
         END;

         IF (ISNULL(@V_OLD_NRCARDAPIO, '!') <> '!')BEGIN
            SET @V_DESC = @V_DESC + ' Card=' + @V_OLD_NRCARDAPIO;
         END;

         IF (ISNULL(@V_OLD_CDSERVFILI, '!') <> '!')BEGIN
            SET @V_DESC = @V_DESC + ' Serv=' + @V_OLD_CDSERVFILI;
         END;

         IF @V_OLD_DTCARDAPIO IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Data=' + CONVERT(VARCHAR, @V_OLD_DTCARDAPIO, 12);
         END;

         IF (ISNULL(@V_OLD_CDDIETPAD, '!') <> '!') BEGIN
            SET @V_DESC = @V_DESC + ' Diet=' + @V_OLD_CDDIETPAD;
         END;

         IF (ISNULL(@V_OLD_QTCOMEFETCAR, 0) <> 0) BEGIN
            SET @V_DESC = @V_DESC + ' Efetivos=' + CONVERT(VARCHAR, @V_OLD_QTCOMEFETCAR);
         END;

         IF (ISNULL(@V_OLD_QTCLIEFETCAR, 0) <> 0) BEGIN
            SET @V_DESC = @V_DESC + ' CliEfet=' + CONVERT(VARCHAR, @V_OLD_QTCLIEFETCAR);
         END;

         IF (ISNULL(@V_OLD_QTFUNEFETCAR, 0) <> 0) BEGIN
            SET @V_DESC = @V_DESC + ' FuncEfet=' + CONVERT(VARCHAR, @V_OLD_QTFUNEFETCAR);
         END;

         IF (ISNULL(@V_OLD_QTDOAEFETCAR, 0) <> 0) BEGIN
            SET @V_DESC = @V_DESC + ' DoaEfet=' + CONVERT(VARCHAR, @V_OLD_QTDOAEFETCAR);
         END;

         IF (ISNULL(@V_OLD_QTCOMESTICAR, 0) <> 0) BEGIN
            SET @V_DESC = @V_DESC + ' Estimados=' + CONVERT(VARCHAR, @V_OLD_QTCOMESTICAR);
         END;

         IF (ISNULL(@V_OLD_QTCLIESTICAR, 0) <> 0) BEGIN
            SET @V_DESC = @V_DESC + ' CliEst=' + CONVERT(VARCHAR, @V_OLD_QTCLIESTICAR);
         END;

         IF (ISNULL(@V_OLD_QTFUNESTICAR, 0) <> 0) BEGIN
            SET @V_DESC = @V_DESC + ' FunEst=' + CONVERT(VARCHAR, @V_OLD_QTFUNESTICAR);
         END;

         IF (ISNULL(@V_OLD_QTDOAESTICAR, 0) <> 0) BEGIN
            SET @V_DESC = @V_DESC + ' DoaEst=' + CONVERT(VARCHAR, @V_OLD_QTDOAESTICAR);
         END;

         IF (ISNULL(@V_OLD_QTESTITURNO1, 0) <> 0) BEGIN
            SET @V_DESC = @V_DESC + ' T1=' + CONVERT(VARCHAR, @V_OLD_QTESTITURNO1);
         END;

         IF (ISNULL(@V_OLD_QTESTITURNO2, 0) <> 0) BEGIN
            SET @V_DESC = @V_DESC + ' T2=' + CONVERT(VARCHAR, @V_OLD_QTESTITURNO2);
         END;

         IF (ISNULL(@V_OLD_QTESTITURNO3, 0) <> 0) BEGIN
            SET @V_DESC = @V_DESC + ' T3=' + CONVERT(VARCHAR, @V_OLD_QTESTITURNO3);
         END;

         IF (ISNULL(@V_OLD_QTESTITURNO4, 0) <> 0) BEGIN
            SET @V_DESC = @V_DESC + ' T4=' + CONVERT(VARCHAR, @V_OLD_QTESTITURNO4);
         END;

         IF (ISNULL(@V_OLD_QTCOMEFETRI, 0) <> 0) BEGIN
            SET @V_DESC = @V_DESC + ' EfetRI=' + CONVERT(VARCHAR, @V_OLD_QTCOMEFETRI);
         END;

         IF (ISNULL(@V_OLD_QTRESTINGECA, 0) <> 0) BEGIN
            SET @V_DESC = @V_DESC + ' TotRI=' + CONVERT(VARCHAR, @V_OLD_QTRESTINGECA);
         END;

         IF (ISNULL(@V_OLD_VRPESPORPERC, 0) <> 0) BEGIN
            SET @V_DESC = @V_DESC + ' PesPor=' + CONVERT(VARCHAR, @V_OLD_VRPESPORPERC);
         END;

         IF (ISNULL(@V_OLD_CDMAIORPRERI, '!') <> '!') BEGIN
            IF (ISNULL(@V_OLD_CDFILAUXPRRI, '!') <> '!') BEGIN
               SET @V_DESC = @V_DESC + ' Prat>PreRI=' + @V_OLD_CDFILAUXPRRI + ' - ' + @V_OLD_CDMAIORPRERI;
            END;
         END;

         IF (ISNULL(@V_OLD_QTCOMEFETSL, 0) <> 0) BEGIN
            SET @V_DESC = @V_DESC + ' EfetSL=' + CONVERT(VARCHAR, @V_OLD_QTCOMEFETSL);
         END;

         IF (ISNULL(@V_OLD_QTSOBRLIMPCA, 0) <> 0) BEGIN
            SET @V_DESC = @V_DESC + ' TotSL=' + CONVERT(VARCHAR, @V_OLD_QTSOBRLIMPCA);
         END;

         IF (ISNULL(@V_OLD_CDMAIORPRESL, '!') <> '!') BEGIN
            IF (ISNULL(@V_OLD_CDFILAUXPRSL, '!') <> '!') BEGIN
               SET @V_DESC = @V_DESC + ' Prat>PreSL=' + @V_OLD_CDFILAUXPRSL + ' - ' + @V_OLD_CDMAIORPRESL;
            END;
         END;

         IF (ISNULL(@V_OLD_DSCARDAPIO, 0) <> 0) BEGIN
            SET @V_DESC = @V_DESC + ' Desc=' + @V_OLD_DSCARDAPIO;
         END;

         SET @V_TIPO = '3';
         SET @V_ITPESQ = @V_OLD_CDFILIAL   +
                         @V_OLD_CDSERVFILI +
                         CONVERT(VARCHAR, @V_OLD_DTCARDAPIO, 12);

      END
      ELSE BEGIN
         IF @V_IDCOMANDO = 'U' /* Updating */ BEGIN
            IF (@V_OLD_CDFILIAL   <> @V_NEW_CDFILIAL  ) OR
               (@V_OLD_NRCARDAPIO <> @V_NEW_NRCARDAPIO) OR
               (@V_OLD_CDSERVFILI <> @V_NEW_CDSERVFILI) OR
               (@V_OLD_CDOPERADOR <> @V_NEW_CDOPERADOR) OR
               (@V_OLD_DTCARDAPIO <> @V_NEW_DTCARDAPIO) OR
               (@V_OLD_DTMESCARD  <> @V_NEW_DTMESCARD ) OR

               (ISNULL(@V_OLD_QTCLIEFETCAR, 0) <> ISNULL(@V_NEW_QTCLIEFETCAR, 0)) OR
               (ISNULL(@V_OLD_QTFUNEFETCAR, 0) <> ISNULL(@V_NEW_QTFUNEFETCAR, 0)) OR
               (ISNULL(@V_OLD_QTDOAEFETCAR, 0) <> ISNULL(@V_NEW_QTDOAEFETCAR, 0)) OR
               (ISNULL(@V_OLD_QTCOMEFETCAR, 0) <> ISNULL(@V_NEW_QTCOMEFETCAR, 0)) OR
               (ISNULL(@V_OLD_QTCLIESTICAR, 0) <> ISNULL(@V_NEW_QTCLIESTICAR, 0)) OR
               (ISNULL(@V_OLD_QTFUNESTICAR, 0) <> ISNULL(@V_NEW_QTFUNESTICAR, 0)) OR
               (ISNULL(@V_OLD_QTDOAESTICAR, 0) <> ISNULL(@V_NEW_QTDOAESTICAR, 0)) OR
               (ISNULL(@V_OLD_QTCOMESTICAR, 0) <> ISNULL(@V_NEW_QTCOMESTICAR, 0)) OR
               (ISNULL(@V_OLD_QTESTITURNO1, 0) <> ISNULL(@V_NEW_QTESTITURNO1, 0)) OR
               (ISNULL(@V_OLD_QTESTITURNO2, 0) <> ISNULL(@V_NEW_QTESTITURNO2, 0)) OR
               (ISNULL(@V_OLD_QTESTITURNO3, 0) <> ISNULL(@V_NEW_QTESTITURNO3, 0)) OR
               (ISNULL(@V_OLD_QTESTITURNO4, 0) <> ISNULL(@V_NEW_QTESTITURNO4, 0)) OR
               (ISNULL(@V_OLD_QTCOMEFETRI,  0) <> ISNULL(@V_NEW_QTCOMEFETRI,  0)) OR
               (ISNULL(@V_OLD_QTRESTINGECA, 0) <> ISNULL(@V_NEW_QTRESTINGECA, 0)) OR
               (ISNULL(@V_OLD_QTCOMEFETSL,  0) <> ISNULL(@V_NEW_QTCOMEFETSL,  0)) OR
               (ISNULL(@V_OLD_VRPESPORPERC, 0) <> ISNULL(@V_NEW_VRPESPORPERC, 0)) OR
               (ISNULL(@V_OLD_QTSOBRLIMPCA, 0) <> ISNULL(@V_NEW_QTSOBRLIMPCA, 0)) OR
               (ISNULL(@V_OLD_CDDIETPAD,    '!') <> ISNULL(@V_NEW_CDDIETPAD,    '!')) OR
               (ISNULL(@V_OLD_CDFILAUXPRRI, '!') <> ISNULL(@V_NEW_CDFILAUXPRRI, '!')) OR
               (ISNULL(@V_OLD_CDMAIORPRERI, '!') <> ISNULL(@V_NEW_CDMAIORPRERI, '!')) OR
               (ISNULL(@V_OLD_CDFILAUXPRSL, '!') <> ISNULL(@V_NEW_CDFILAUXPRSL, '!')) OR
               (ISNULL(@V_OLD_CDMAIORPRESL, '!') <> ISNULL(@V_NEW_CDMAIORPRESL, '!')) OR
               (ISNULL(@V_OLD_DSCARDAPIO,   '!') <> ISNULL(@V_NEW_DSCARDAPIO,   '!')) BEGIN

               SET @V_TIPO  = '2';
               SET @V_ITPESQ = @V_OLD_CDFILIAL   +
                               @V_OLD_CDSERVFILI +
                               CONVERT(VARCHAR, @V_OLD_DTCARDAPIO, 12);

            END;
         END
         ELSE BEGIN
            SET @V_TIPO   = '1';
            SET @V_ITPESQ = @V_NEW_CDFILIAL   +
                            @V_NEW_CDSERVFILI +
                            CONVERT(VARCHAR, @V_NEW_DTCARDAPIO, 12);
         END;

         IF @V_NEW_CDFILIAL IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Fili=' + @V_NEW_CDFILIAL;
         END;

         IF @V_NEW_NRCARDAPIO IS NOT NULL  BEGIN
            SET @V_DESC = @V_DESC + ' Card=' + @V_NEW_NRCARDAPIO;
         END;

         IF @V_NEW_CDSERVFILI IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Serv=' + @V_NEW_CDSERVFILI;
         END;

         IF @V_NEW_DTCARDAPIO IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Data=' + CONVERT(VARCHAR, @V_NEW_DTCARDAPIO, 12);
         END;

         IF (ISNULL(@V_OLD_CDDIETPAD, '!') <> ISNULL(@V_NEW_CDDIETPAD, '!')) BEGIN
            IF @V_IDCOMANDO = 'U' BEGIN
               SET @V_DESC = @V_DESC + ' Diet=' + @V_OLD_CDDIETPAD + '|' + @V_NEW_CDDIETPAD;
            END;
            ELSE BEGIN
               SET @V_DESC = @V_DESC + ' Diet=' + @V_NEW_CDDIETPAD;
            END;
         END;

         IF (ISNULL(@V_OLD_QTCOMEFETCAR, 0) <> ISNULL(@V_NEW_QTCOMEFETCAR, 0)) BEGIN
            IF @V_IDCOMANDO = 'U' BEGIN
               SET @V_DESC = @V_DESC + ' Efetivos=' + CONVERT(VARCHAR, @V_OLD_QTCOMEFETCAR) + '|' + CONVERT(VARCHAR, @V_NEW_QTCOMEFETCAR);
            END;
            ELSE BEGIN
               SET @V_DESC = @V_DESC + ' Efetivos=' + CONVERT(VARCHAR, @V_NEW_QTCOMEFETCAR);
            END;
         END;

         IF (ISNULL(@V_OLD_QTCLIEFETCAR, 0) <> ISNULL(@V_NEW_QTCLIEFETCAR, 0)) BEGIN
            IF @V_IDCOMANDO = 'U' BEGIN
               SET @V_DESC = @V_DESC + ' CliEfet=' + CONVERT(VARCHAR, @V_OLD_QTCLIEFETCAR) + '|' + CONVERT(VARCHAR, @V_NEW_QTCLIEFETCAR);
            END;
            ELSE BEGIN
               SET @V_DESC = @V_DESC + ' CliEfet=' + CONVERT(VARCHAR, @V_NEW_QTCLIEFETCAR);
            END;
         END;

         IF (ISNULL(@V_OLD_QTFUNEFETCAR, 0) <> ISNULL(@V_NEW_QTFUNEFETCAR, 0)) BEGIN
            IF @V_IDCOMANDO = 'U' BEGIN
               SET @V_DESC = @V_DESC + ' FuncEfet=' + CONVERT(VARCHAR, @V_OLD_QTFUNEFETCAR) + '|' + CONVERT(VARCHAR, @V_NEW_QTFUNEFETCAR);
            END;
            ELSE BEGIN
               SET @V_DESC = @V_DESC + ' FuncEfet=' + CONVERT(VARCHAR, @V_NEW_QTFUNEFETCAR);
            END;
         END;

         IF (ISNULL(@V_OLD_QTDOAEFETCAR, 0) <> ISNULL(@V_NEW_QTDOAEFETCAR, 0)) BEGIN
            IF @V_IDCOMANDO = 'U' BEGIN
               SET @V_DESC = @V_DESC + ' DoaEfet=' + CONVERT(VARCHAR, @V_OLD_QTDOAEFETCAR) + '|' + CONVERT(VARCHAR, @V_NEW_QTDOAEFETCAR);
            END;
            ELSE BEGIN
               SET @V_DESC = @V_DESC + ' DoaEfet=' + CONVERT(VARCHAR, @V_NEW_QTDOAEFETCAR);
            END;
         END;

         IF (ISNULL(@V_OLD_QTCOMESTICAR, 0) <> ISNULL(@V_NEW_QTCOMESTICAR, 0)) BEGIN
            IF @V_IDCOMANDO = 'U' BEGIN
               SET @V_DESC = @V_DESC + ' Estimados=' + CONVERT(VARCHAR, @V_OLD_QTCOMESTICAR) + '|' + CONVERT(VARCHAR, @V_NEW_QTCOMESTICAR);
            END;
            ELSE BEGIN
               SET @V_DESC = @V_DESC + ' Estimados=' + CONVERT(VARCHAR, @V_NEW_QTCOMESTICAR);
            END;
         END;

         IF (ISNULL(@V_OLD_QTCLIESTICAR, 0) <> ISNULL(@V_NEW_QTCLIESTICAR, 0)) BEGIN
            IF @V_IDCOMANDO = 'U' BEGIN
               SET @V_DESC = @V_DESC + ' CliEst=' + CONVERT(VARCHAR, @V_OLD_QTCLIESTICAR) + '|' + CONVERT(VARCHAR, @V_NEW_QTCLIESTICAR);
            END;
            ELSE BEGIN
               SET @V_DESC = @V_DESC + ' CliEst=' + CONVERT(VARCHAR, @V_NEW_QTCLIESTICAR);
            END;
         END;

         IF (ISNULL(@V_OLD_QTFUNESTICAR, 0) <> ISNULL(@V_NEW_QTFUNESTICAR, 0)) BEGIN
            IF @V_IDCOMANDO = 'U' BEGIN
               SET @V_DESC = @V_DESC + ' FunEst=' + CONVERT(VARCHAR, @V_OLD_QTFUNESTICAR) + '|' + CONVERT(VARCHAR, @V_NEW_QTFUNESTICAR);
            END;
            ELSE BEGIN
               SET @V_DESC = @V_DESC + ' FunEst=' + CONVERT(VARCHAR, @V_NEW_QTFUNESTICAR);
            END;
         END;

         IF (ISNULL(@V_OLD_QTDOAESTICAR, 0) <> ISNULL(@V_NEW_QTDOAESTICAR, 0)) BEGIN
            IF @V_IDCOMANDO = 'U' BEGIN
               SET @V_DESC = @V_DESC + ' DoaEst=' + CONVERT(VARCHAR, @V_OLD_QTDOAESTICAR) + '|' + CONVERT(VARCHAR, @V_NEW_QTDOAESTICAR);
            END;
            ELSE BEGIN
               SET @V_DESC = @V_DESC + ' DoaEst=' + CONVERT(VARCHAR, @V_NEW_QTDOAESTICAR);
            END;
         END;

         IF (ISNULL(@V_OLD_QTESTITURNO1, 0) <> ISNULL(@V_NEW_QTESTITURNO1, 0)) BEGIN
            IF @V_IDCOMANDO = 'U' BEGIN
               SET @V_DESC = @V_DESC + ' T1=' + CONVERT(VARCHAR, @V_OLD_QTESTITURNO1) + '|' + CONVERT(VARCHAR, @V_NEW_QTESTITURNO1);
            END;
            ELSE BEGIN
               SET @V_DESC = @V_DESC + ' T1=' + CONVERT(VARCHAR, @V_NEW_QTESTITURNO1);
            END;
         END;

         IF (ISNULL(@V_OLD_QTESTITURNO2, 0) <> ISNULL(@V_NEW_QTESTITURNO2, 0)) BEGIN
            IF @V_IDCOMANDO = 'U' BEGIN
               SET @V_DESC = @V_DESC + ' T2=' + CONVERT(VARCHAR, @V_OLD_QTESTITURNO2) + '|' + CONVERT(VARCHAR, @V_NEW_QTESTITURNO2);
            END;
            ELSE BEGIN
               SET @V_DESC = @V_DESC + ' T2=' + CONVERT(VARCHAR, @V_NEW_QTESTITURNO2);
            END;
         END;

         IF (ISNULL(@V_OLD_QTESTITURNO3, 0) <> ISNULL(@V_NEW_QTESTITURNO3, 0)) BEGIN
            IF @V_IDCOMANDO = 'U' BEGIN
               SET @V_DESC = @V_DESC + ' T3=' + CONVERT(VARCHAR, @V_OLD_QTESTITURNO3) + '|' + CONVERT(VARCHAR, @V_NEW_QTESTITURNO3);
            END;
            ELSE BEGIN
               SET @V_DESC = @V_DESC + ' T3=' + CONVERT(VARCHAR, @V_NEW_QTESTITURNO3);
            END;
         END;

         IF (ISNULL(@V_OLD_QTESTITURNO4, 0) <> ISNULL(@V_NEW_QTESTITURNO4, 0)) BEGIN
            IF @V_IDCOMANDO = 'U' BEGIN
               SET @V_DESC = @V_DESC + ' T4=' + CONVERT(VARCHAR, @V_OLD_QTESTITURNO4) + '|' + CONVERT(VARCHAR, @V_NEW_QTESTITURNO4);
            END;
            ELSE BEGIN
               SET @V_DESC = @V_DESC + ' T4=' + CONVERT(VARCHAR, @V_NEW_QTESTITURNO4);
            END;
         END;

         IF (ISNULL(@V_OLD_QTCOMEFETRI, 0) <> ISNULL(@V_NEW_QTCOMEFETRI, 0)) BEGIN
            IF @V_IDCOMANDO = 'U' BEGIN
               SET @V_DESC = @V_DESC + ' EfetRI=' + CONVERT(VARCHAR, @V_OLD_QTCOMEFETRI) + '|' + CONVERT(VARCHAR, @V_NEW_QTCOMEFETRI);
            END;
            ELSE BEGIN
               SET @V_DESC = @V_DESC + ' EfetRI=' + CONVERT(VARCHAR, @V_NEW_QTCOMEFETRI);
            END;
         END;

         IF (ISNULL(@V_OLD_QTRESTINGECA, 0) <> ISNULL(@V_NEW_QTRESTINGECA, 0)) BEGIN
            IF @V_IDCOMANDO = 'U' BEGIN
               SET @V_DESC = @V_DESC + ' TotRI=' + CONVERT(VARCHAR, @V_OLD_QTRESTINGECA) + '|' + CONVERT(VARCHAR, @V_NEW_QTRESTINGECA);
            END;
            ELSE BEGIN
               SET @V_DESC = @V_DESC + ' TotRI=' + CONVERT(VARCHAR, @V_NEW_QTRESTINGECA);
            END;
         END;

         IF (ISNULL(@V_OLD_VRPESPORPERC, 0) <> ISNULL(@V_NEW_VRPESPORPERC, 0)) BEGIN
            IF @V_IDCOMANDO = 'U' BEGIN
               SET @V_DESC = @V_DESC + ' PesPor=' + CONVERT(VARCHAR, @V_OLD_VRPESPORPERC) + '|' + CONVERT(VARCHAR, @V_NEW_VRPESPORPERC);
            END;
            ELSE BEGIN
               SET @V_DESC = @V_DESC + ' PesPor=' + CONVERT(VARCHAR, @V_NEW_VRPESPORPERC);
            END;
         END;

         IF @V_IDCOMANDO = 'U' BEGIN
            IF (ISNULL(@V_OLD_CDFILAUXPRRI, '!') <> ISNULL(@V_NEW_CDFILAUXPRRI, '!')) BEGIN
               SET @V_DESC = @V_DESC + ' Prat>PreRI=' + @V_OLD_CDFILAUXPRRI + '|' + @V_NEW_CDFILAUXPRRI;
            END;
            IF (ISNULL(@V_OLD_CDMAIORPRERI, '!') <> ISNULL(@V_NEW_CDMAIORPRERI, '!')) BEGIN
               IF (ISNULL(@V_OLD_CDFILAUXPRRI, '!') <> ISNULL(@V_NEW_CDFILAUXPRRI, '!')) BEGIN
                  SET @V_DESC = @V_DESC + ' - ' + @V_OLD_CDMAIORPRERI + '|' + @V_NEW_CDMAIORPRERI;
               END;
               ELSE BEGIN
                  SET @V_DESC = @V_DESC + ' Prat>PreRI=' + @V_OLD_CDMAIORPRERI + '|' + @V_NEW_CDMAIORPRERI;
               END;
            END;
         END;
         ELSE BEGIN
            IF (ISNULL(@V_OLD_CDMAIORPRERI, '!') <> ISNULL(@V_NEW_CDMAIORPRERI, '!')) BEGIN
               IF (ISNULL(@V_OLD_CDFILAUXPRRI, '!') <> ISNULL(@V_NEW_CDFILAUXPRRI, '!')) BEGIN
                  SET @V_DESC = @V_DESC + ' Prat>PreRI=' + @V_NEW_CDFILAUXPRRI + ' - ' + @V_NEW_CDMAIORPRERI;
               END
            END;
         END;

         IF (ISNULL(@V_OLD_QTCOMEFETSL, 0) <> ISNULL(@V_NEW_QTCOMEFETSL, 0)) BEGIN
            IF @V_IDCOMANDO = 'U' BEGIN
               SET @V_DESC = @V_DESC + ' EfetSL=' + CONVERT(VARCHAR, @V_OLD_QTCOMEFETSL) + '|' + CONVERT(VARCHAR, @V_NEW_QTCOMEFETSL);
            END;
            ELSE BEGIN
               SET @V_DESC = @V_DESC + ' EfetSL=' + CONVERT(VARCHAR, @V_NEW_QTCOMEFETSL);
            END;
         END;

         IF (ISNULL(@V_OLD_QTSOBRLIMPCA, 0) <> ISNULL(@V_NEW_QTSOBRLIMPCA, 0)) BEGIN
            IF @V_IDCOMANDO = 'U' BEGIN
               SET @V_DESC = @V_DESC + ' TotSL=' + CONVERT(VARCHAR, @V_OLD_QTSOBRLIMPCA) + '|' + CONVERT(VARCHAR, @V_NEW_QTSOBRLIMPCA);
            END;
            ELSE BEGIN
               SET @V_DESC = @V_DESC + ' TotSL=' + CONVERT(VARCHAR, @V_NEW_QTSOBRLIMPCA);
            END;
         END;

         IF @V_IDCOMANDO = 'U' BEGIN
            IF (ISNULL(@V_OLD_CDFILAUXPRSL, '!') <> ISNULL(@V_NEW_CDFILAUXPRSL, '!')) BEGIN
               SET @V_DESC = @V_DESC + ' Prat>PreSL=' + @V_OLD_CDFILAUXPRSL + '|' + @V_NEW_CDFILAUXPRSL;
            END;
            IF (ISNULL(@V_OLD_CDMAIORPRESL, '!') <> ISNULL(@V_NEW_CDMAIORPRESL, '!')) BEGIN
               IF (ISNULL(@V_OLD_CDFILAUXPRSL, '!') <> ISNULL(@V_NEW_CDFILAUXPRSL, '!')) BEGIN
                  SET @V_DESC = @V_DESC + ' - ' + @V_OLD_CDMAIORPRESL + '|' + @V_NEW_CDMAIORPRESL;
               END;
               ELSE BEGIN
                  SET @V_DESC = @V_DESC + ' Prat>PreSL=' + @V_OLD_CDMAIORPRESL + '|' + @V_NEW_CDMAIORPRESL;
               END;
            END;
         END;
         ELSE BEGIN
            IF (ISNULL(@V_OLD_CDMAIORPRESL, '!') <> ISNULL(@V_NEW_CDMAIORPRESL, '!')) BEGIN
               IF (ISNULL(@V_OLD_CDFILAUXPRSL, '!') <> ISNULL(@V_NEW_CDFILAUXPRSL, '!')) BEGIN
                  SET @V_DESC = @V_DESC + ' Prat>PreSL=' + @V_NEW_CDFILAUXPRSL + ' - ' + @V_NEW_CDMAIORPRESL;
               END;
            END;
         END;


         IF (ISNULL(@V_OLD_DSCARDAPIO, 0) <> ISNULL(@V_NEW_DSCARDAPIO, 0)) BEGIN
            IF @V_IDCOMANDO = 'U' BEGIN
               SET @V_DESC = @V_DESC + ' Desc=' + @V_OLD_DSCARDAPIO + '|' + @V_NEW_DSCARDAPIO;
            END;
            ELSE BEGIN
               SET @V_DESC = @V_DESC + ' Desc=' + @V_NEW_DSCARDAPIO;
            END;
         END;
      END;

      IF @V_TIPO <> '0' BEGIN
         IF NOT @V_DESC IS NULL BEGIN
            SET @V_USUARIO = '  ';
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER =  GETDATE();
	       SELECT
                   @V_DSSERVERRDM  = DSSERVERRDM,
                   @V_DSREMOTEADDR = DSREMOTEADDR,
                   @V_DSREMOTEHOST = DSREMOTEHOST,
		   @V_DSSERVMETHOD = DSSERVMETHOD,
                   @V_DSREMOTEOPER = DSREMOTEOPER
	       FROM
                  SQLWEBTUNNING;
               INSERT INTO LOGOPERA
                  (NMTABELA,   DTOPERACAO, NMRESPOPER, IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                   DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
               VALUES
                  ('CARDADIA',  @V_DTOPER, @V_USUARIO, @V_TIPO,  @V_ITPESQ, @V_DESC,
                   @V_DSSERVERRDM, @V_DSREMOTEADDR,  @V_DSREMOTEHOST, @V_DSSERVMETHOD, @V_DSREMOTEOPER);
            END;  
         END;
      END;


      FETCH NEXT FROM C_DADOS INTO @V_IDCOMANDO,
                                   @V_NEW_CDFILIAL,
                                   @V_NEW_NRCARDAPIO,
                                   @V_NEW_CDSERVFILI,
                                   @V_NEW_CDOPERADOR,
                                   @V_NEW_DTCARDAPIO,
                                   @V_NEW_DTMESCARD,
                                   @V_NEW_QTCLIEFETCAR,
                                   @V_NEW_QTFUNEFETCAR,
                                   @V_NEW_QTDOAEFETCAR,
                                   @V_NEW_QTCOMEFETCAR,
                                   @V_NEW_QTCLIESTICAR,
                                   @V_NEW_QTFUNESTICAR,
                                   @V_NEW_QTDOAESTICAR,
                                   @V_NEW_QTCOMESTICAR,
                                   @V_NEW_QTESTITURNO1,
                                   @V_NEW_QTESTITURNO2,
                                   @V_NEW_QTESTITURNO3,
                                   @V_NEW_QTESTITURNO4,
                                   @V_NEW_QTCOMEFETRI,
                                   @V_NEW_QTRESTINGECA,
                                   @V_NEW_QTCOMEFETSL,
                                   @V_NEW_VRPESPORPERC,
                                   @V_NEW_QTSOBRLIMPCA,
                                   @V_NEW_CDDIETPAD,
                                   @V_NEW_CDFILAUXPRRI,
                                   @V_NEW_CDMAIORPRERI,
                                   @V_NEW_CDFILAUXPRSL,
                                   @V_NEW_CDMAIORPRESL,
                                   @V_NEW_DSCARDAPIO,

                                   @V_OLD_CDFILIAL,
                                   @V_OLD_NRCARDAPIO,
                                   @V_OLD_CDSERVFILI,
                                   @V_OLD_CDOPERADOR,
                                   @V_OLD_DTCARDAPIO,
                                   @V_OLD_DTMESCARD,
                                   @V_OLD_QTCLIEFETCAR,
                                   @V_OLD_QTFUNEFETCAR,
                                   @V_OLD_QTDOAEFETCAR,
                                   @V_OLD_QTCOMEFETCAR,
                                   @V_OLD_QTCLIESTICAR,
                                   @V_OLD_QTFUNESTICAR,
                                   @V_OLD_QTDOAESTICAR,
                                   @V_OLD_QTCOMESTICAR,
                                   @V_OLD_QTESTITURNO1,
                                   @V_OLD_QTESTITURNO2,
                                   @V_OLD_QTESTITURNO3,
                                   @V_OLD_QTESTITURNO4,
                                   @V_OLD_QTCOMEFETRI,
                                   @V_OLD_QTRESTINGECA,
                                   @V_OLD_QTCOMEFETSL,
                                   @V_OLD_VRPESPORPERC,
                                   @V_OLD_QTSOBRLIMPCA,
                                   @V_OLD_CDDIETPAD,
                                   @V_OLD_CDFILAUXPRRI,
                                   @V_OLD_CDMAIORPRERI,
                                   @V_OLD_CDFILAUXPRSL,
                                   @V_OLD_CDMAIORPRESL,
                                   @V_OLD_DSCARDAPIO
   END;
   CLOSE      C_DADOS;
   DEALLOCATE C_DADOS;
END;
GO




-- VERSAO --
EXEC ATUVEROBJ 'LOG_PLA_CARDADIA','5.01.016';
GO

