const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geral = new Helper.geral();
const loginPage = new Helper.login();
const protractorHelper = require('protractor-helper');
const j = require('../../../json/leitorJson.po.js');
const contaCorrentePage = require('../../../page-objects/parametrizacao/financeiro/contaCorrente.po');

const faixaNumeroMaior = 9999999999999999;
const faixaNumeroMenor = 1000000000000000;
const contaCorrenteGridId = '1547514630820780607600';
const nossoNumero = Helper.util.geraInt(10000, 1000000);
const empresa = j.getValor('empresa').concat(' Teknisa');
const cip = Helper.util.geraInt(999, 99999);
const codigoReduzido = Helper.util.geraInt(100, 999);
describe('Tela Conta Corrente', () => {
	beforeAll(() => {
		browser.get('http://erpteste.teknisa.com/login/');
		loginPage.login(j.getValor('login'), j.getValor('senha'));
		contaCorrentePage.abrir();
		contaCorrentePage.selectAgencia(j.getValor('banco'), j.getValor('agencia'));
		protractorHelper.waitForElementVisibility(element(by.id(`grid-${contaCorrenteGridId}`)),
			5000);
	});

	afterAll(() => {
		geral.sair();
	});

	it('Acessar tela Conta Corrente', () => {
		expect(z.component.header.getTitle()).toBe('Conta Corrente');
	});

	it('Adicionar Conta Corrente', () => {
		geral.clickAdicionar();
		contaCorrentePage.adicionaContaCorrente(codigoReduzido, j.getValor('contaCorrente'),
			j.getValor('tipoCC'), j.getValor('descricao'), empresa, j.getValor('contaContabil'), 'Sim');
		geral.clickSalvar();
		geral.clickNão();
		geral.esperarLoading();

		expect(geral.gridHasText(contaCorrenteGridId, codigoReduzido, 0, true))
			.toMatch(codigoReduzido);
		expect(geral.gridHasText(contaCorrenteGridId, j.getValor('contaCorrente'), 1, true))
			.toMatch(j.getValor('contaCorrente'));
		expect(geral.gridHasText(contaCorrenteGridId, empresa, 4, true))
			.toMatch(empresa);
	});

	const implantacaoGridId = '15475146303521341482657';
	const digitoVerificador = Helper.util.geraInt(1, 9);
	const codigoCedente = Helper.util.geraInt(10000, 999999);
	const percentualAlerta = Helper.util.geraInt(1, 99);
	const valorCredito = Helper.util.geraInt(10000, 10000000);
	const valorCredito2 = Helper.util.geraInt(10000, 10000000);

	const nossoNumeroModificado = Helper.util.geraInt(10000, 1000000);
	const digitoVerificadorModificado = Helper.util.geraInt(1, 9);
	const cipModificado = Helper.util.geraInt(999, 99999);
	const numDeModificado = Helper.util.geraInt(1000000000000, 9999999999999);

	it('Adicionar Dados Adicionais', () => {
		geral.clickGrid('CDCONTCORR', j.getValor('contaCorrente'), contaCorrenteGridId);
		geral.trocarAba('Dados Adicionais');
		contaCorrentePage.editaDadosAdicionais(nossoNumero, digitoVerificador, codigoCedente,
			j.getValor('nomePessoa'), Helper.util.geraInt(9999, 999999), Helper.util.geraInt(9999, 999999),
			'Não', Helper.util.geraInt(1000000000000, 9999999999999),
			Helper.util.geraInt(faixaNumeroMenor, faixaNumeroMaior), 'Não', Helper.util.geraInt(faixaNumeroMenor,
				faixaNumeroMaior), Helper.util.geraInt(faixaNumeroMenor, faixaNumeroMaior),
			Helper.util.geraInt(9999, 999999), cip);
		geral.waitFieldVisibility('NRININOSNUMP');

		expect(z.widget.formView.getFieldValue('NRININOSNUMP'))
			.toBe('');
		expect(z.widget.formView.getFieldValue('DSDACNOSNUMR'))
			.toBe(digitoVerificador);
		expect(z.widget.formView.getFieldValue('NRCIPCONTCORR'))
			.toBe(cip);
		expect(z.widget.formView.getFieldValue('NMCEDENTEBAN'))
			.toBe(j.getValor('nomePessoa'));
		geral.clickVoltar();
	});

	it('Adicionar Limite de Crédito', () => {
		geral.clickGrid('CDCONTCORR', j.getValor('contaCorrente'), contaCorrenteGridId);
		geral.trocarAba('Limite de Crédito');
		geral.clickEditar();
		contaCorrentePage.adicionaLimiteCredito(valorCredito, valorCredito2, percentualAlerta,
			j.getValor('valor'));
		geral.clickAcoes();
		geral.esperarLoading();
		geral.clickActionPorIndice(1);
		geral.clickCancelar();
		geral.waitFieldVisibility('VRCTRCREDCHQ');

		expect(z.widget.formView.getFieldValue('VRCTRCREDCHQ'))
			.toMatch(Helper.util.formataReal(valorCredito));
		expect(z.widget.formView.getFieldValue('VRCTRCOBDESC'))
			.toMatch(Helper.util.formataReal(valorCredito2));
		expect(z.widget.formView.getFieldValue('VRPERCOBDESC'))
			.toBe(percentualAlerta);
		geral.clickVoltar();
	});

	it('Adcionar Implantação de Saldo', () => {
		geral.clickGrid('CDCONTCORR', j.getValor('contaCorrente'), contaCorrenteGridId);
		geral.trocarAba('Implantação de Saldo');
		geral.clickAdicionar();
		contaCorrentePage.adicionaImplantacao(j.getValor('data'), j.getValor('valor'));
		protractorHelper.waitForElementVisibility(element(by.id(`grid-${implantacaoGridId}`)),
			5000);

		expect(geral.gridHasText(implantacaoGridId, j.getValor('data')))
			.toMatch(j.getValor('data'));
	});

	it('Alterar Conta Corrente', () => {
		geral.clickGrid('CDCONTCORR', j.getValor('contaCorrente'), contaCorrenteGridId);
		contaCorrentePage.altera('Garantida', j.getValor('descricao').concat(' Peb'), 'Não');
		geral.waitFieldVisibility('IDTIPOCCORR');

		expect(z.widget.formView.getFieldValue('IDTIPOCCORR'))
			.toEqual('Garantida');
		expect(z.widget.formView.getFieldValue('NMCONTCTBL'))
			.toEqual(j.getValor('contaContabil'));
		expect(z.widget.formView.getFieldValue('IDATIVO'))
			.toEqual('Não');
		expect(z.widget.formView.getFieldValue('DSCONTCORR'))
			.toEqual(j.getValor('descricao').concat(' Peb'));
		geral.clickVoltar();
	});

	it('Alterar Dados Adicionais', () => {
		geral.clickGrid('CDCONTCORR', j.getValor('contaCorrente'), contaCorrenteGridId);
		geral.trocarAba('Dados Adicionais');
		contaCorrentePage.editaDadosAdicionais(nossoNumeroModificado,
			digitoVerificadorModificado, Helper.util.geraInt(10000, 999999),
			j.getValor('nomePessoa').concat(' Das Luzes'),
			Helper.util.geraInt(9999, 999999), Helper.util.geraInt(9999, 999999), 'Sim',
			numDeModificado, Helper.util.geraInt(faixaNumeroMenor, faixaNumeroMaior),
			'Sim', Helper.util.geraInt(1000000000000, 9999999999999),
			Helper.util.geraInt(faixaNumeroMenor, faixaNumeroMaior),
			Helper.util.geraInt(9999, 999999), cipModificado);
		geral.waitFieldVisibility('NRININOSNUMP');

		expect(z.widget.formView.getFieldValue('NRININOSNUMP'))
			.toMatch(numDeModificado);
		expect(z.widget.formView.getFieldValue('NRCIPCONTCORR'))
			.toMatch(cipModificado);
		expect(z.widget.formView.getFieldValue('DSDACNOSNUMR'))
			.toBe(digitoVerificadorModificado);
		expect(z.widget.formView.getFieldValue('NMCEDENTEBAN'))
			.toBe(j.getValor('nomePessoa').concat(' Das Luzes'));
		geral.clickVoltar();
	});

	it('Alterar Limite de Crédito', () => {
		geral.clickGrid('CDCONTCORR', j.getValor('contaCorrente'), contaCorrenteGridId);
		const limit = Helper.util.geraInt(10000000, 999999999);
		geral.trocarAba('Limite de Crédito');
		geral.clickEditar();
		contaCorrentePage.alteraLimiteDeCredito(limit);
		geral.clickAcoes();
		geral.esperarLoading();
		geral.clickActionPorIndice(1);
		geral.clickCancelar();
		geral.waitFieldVisibility('VRCTRCREDCHQ');

		expect(z.widget.formView.getFieldValue('VRCTRCREDCHQ'))
			.toBe('');
		expect(z.widget.formView.getFieldValue('VRCTRCOBDESC'))
			.toBe('');
		expect(z.widget.formView.getFieldValue('VRLIMITCREDCCOR'))
			.toBe(Helper.util.formataReal(limit));
		geral.clickVoltar();
	});

	it('Excluir Implantação de Saldo', () => {
		geral.clickGrid('CDCONTCORR', j.getValor('contaCorrente'), contaCorrenteGridId);
		geral.trocarAba('Implantação de Saldo');
		geral.clickGrid('DTSDOCCORR', j.getValor('data'), implantacaoGridId);
		geral.esperarLoading();
		contaCorrentePage.apaga();
		geral.esperarLoading();

		expect(z.component.alert.getText())
			.toEqual('Registro excluído com sucesso.');
		geral.clickOk();
	});

	it('Excluir Conta Corrente', () => {
		geral.clickGrid('CDCONTCORR', j.getValor('contaCorrente'), contaCorrenteGridId);
		contaCorrentePage.apaga();
		protractorHelper.waitForElementVisibility(
			element(by.id(`grid-${contaCorrenteGridId}`)), 5000);

		expect(geral.gridHasText(contaCorrenteGridId, j.getValor('contaCorrente'), 1, true))
			.toBeUndefined();
	});
});
